1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # http://article.gmane.org/gmane.comp.version-control.git/22407
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo
="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg
="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg
="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg
="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
53 rewritten
="$state_dir"/rewritten
55 dropped
="$state_dir"/dropped
58 msgnum
="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
63 author_script
="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend
="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list
="$state_dir"/rewritten-list
78 rewritten_pending
="$state_dir"/rewritten-pending
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
85 if test -n "$do_merge"
87 strategy_args
=${strategy:+--strategy=$strategy}
89 for strategy_opt in '"$strategy_opts"'
91 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
96 GIT_CHERRY_PICK_HELP
="$resolvemsg"
97 export GIT_CHERRY_PICK_HELP
99 comment_char
=$
(git config
--get core.commentchar
2>/dev
/null | cut
-c1)
103 printf '%s\n' "$*" >&2
106 # Output the commit message for the specified commit.
108 git cat-file commit
"$1" |
sed "1,/^$/d"
111 orig_reflog_action
="$GIT_REFLOG_ACTION"
113 comment_for_reflog
() {
114 case "$orig_reflog_action" in
116 GIT_REFLOG_ACTION
="rebase -i ($1)"
117 export GIT_REFLOG_ACTION
123 mark_action_done
() {
124 sed -e 1q
< "$todo" >> "$done"
125 sed -e 1d
< "$todo" >> "$todo".new
126 mv -f "$todo".new
"$todo"
127 new_count
=$
(git stripspace
--strip-comments <"$done" |
wc -l)
128 echo $new_count >"$msgnum"
129 total
=$
(($new_count + $
(git stripspace
--strip-comments <"$todo" |
wc -l)))
131 if test "$last_count" != "$new_count"
133 last_count
=$new_count
134 printf "Rebasing (%d/%d)\r" $new_count $total
135 test -z "$verbose" ||
echo
139 # Put the last action marked done at the beginning of the todo list
140 # again. If there has not been an action marked done yet, leave the list of
141 # items on the todo list unchanged.
142 reschedule_last_action
() {
143 tail -n 1 "$done" |
cat - "$todo" >"$todo".new
144 sed -e \
$d <"$done" >"$done".new
145 mv -f "$todo".new
"$todo"
146 mv -f "$done".new
"$done"
149 append_todo_help
() {
150 git stripspace
--comment-lines >>"$todo" <<\EOF
154 r
, reword
= use commit
, but edit the commit message
155 e
, edit
= use commit
, but stop
for amending
156 s
, squash
= use commit
, but meld into previous commit
157 f
, fixup
= like
"squash", but discard this commit
's log message
158 x, exec = run command (the rest of the line) using shell
159 d, drop = remove commit
161 These lines can be re-ordered; they are executed from top to bottom.
164 if test $(get_missing_commit_check_level) = error
166 git stripspace --comment-lines >>"$todo" <<\EOF
167 Do not remove any line. Use 'drop
' explicitly to remove a commit.
170 git stripspace --comment-lines >>"$todo" <<\EOF
171 If you remove a line here THAT COMMIT WILL BE LOST.
177 sha1_and_parents="$(git rev-list --parents -1 "$1")"
178 case "$sha1_and_parents" in
180 git diff --cc $sha1_and_parents
183 git diff-tree -p "$1^!"
188 esac > "$state_dir"/patch
190 commit_message "$1" > "$msg"
191 test -f "$author_script" ||
192 get_author_ident_from_commit "$1" > "$author_script"
196 echo "$1" > "$state_dir"/stopped-sha
203 echo "$1" > "$state_dir"/stopped-sha
205 git rev-parse --verify HEAD > "$amend"
206 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
207 warn "You can amend the commit now, with"
209 warn " git commit --amend $gpg_sign_opt_quoted"
211 warn "Once you are satisfied with your changes, run"
213 warn " git rebase --continue"
224 test -n "$(git stripspace --strip-comments <"$1")"
228 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
229 die "$1: not a commit that can be picked")
230 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
231 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
232 test "$tree" = "$ptree"
237 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
240 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
241 # GIT_AUTHOR_DATE exported from the current environment.
244 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
249 git_sequence_editor () {
250 if test -z "$GIT_SEQUENCE_EDITOR"
252 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
253 if [ -z "$GIT_SEQUENCE_EDITOR" ]
255 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
259 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
265 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
266 case "$force_rebase" in '') ;; ?*) ff= ;; esac
267 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
269 if is_empty_commit "$sha1"
271 empty_args="--allow-empty"
274 test -d "$rewritten" &&
275 pick_one_preserving_merges "$@" && return
276 output eval git cherry-pick \
277 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
278 "$strategy_args" $empty_args $ff "$@"
280 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
281 # previous task so this commit is not lost.
283 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
287 pick_one_preserving_merges () {
298 sha1=$(git rev-parse $sha1)
300 if test -f "$state_dir"/current-commit
302 if test "$fast_forward" = t
304 while read current_commit
306 git rev-parse HEAD > "$rewritten"/$current_commit
307 done <"$state_dir"/current-commit
308 rm "$state_dir"/current-commit ||
309 die "Cannot write current commit's replacement sha1
"
313 echo $sha1 >> "$state_dir"/current-commit
315 # rewrite parents; if none were rewritten, we can fast-forward.
317 pend=" $
(git rev-list
--parents -1 $sha1 | cut
-d' ' -s -f2-)"
318 if test "$pend" = " "
322 while [ "$pend" != "" ]
324 p=$(expr "$pend" : ' \([^ ]*\)')
327 if test -f "$rewritten"/$p
329 new_p=$(cat "$rewritten"/$p)
331 # If the todo reordered commits, and our parent is marked for
332 # rewriting, but hasn't been gotten to yet, assume the user meant to
333 # drop it on top of the current HEAD
336 new_p=$(git rev-parse HEAD)
339 test $p != $new_p && fast_forward=f
340 case "$new_parents" in
342 ;; # do nothing; that parent is already there
344 new_parents="$new_parents $new_p"
348 if test -f "$dropped"/$p
351 replacement="$
(cat "$dropped"/$p)"
352 test -z "$replacement" && replacement=root
353 pend=" $replacement$pend"
355 new_parents="$new_parents $p"
359 case $fast_forward in
361 output warn "Fast-forward to
$sha1"
362 output git reset --hard $sha1 ||
363 die "Cannot fast-forward to
$sha1"
366 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
370 # detach HEAD to current parent
371 output git checkout $first_parent 2> /dev/null ||
372 die "Cannot move HEAD to
$first_parent"
375 case "$new_parents" in
377 test "a
$1" = a-n && die "Refusing to squash a merge
: $sha1"
380 author_script_content=$(get_author_ident_from_commit $sha1)
381 eval "$author_script_content"
382 msg_content="$
(commit_message
$sha1)"
383 # No point in merging the first parent, that's HEAD
384 new_parents=${new_parents# $first_parent}
385 if test -z "$first_parent_only"
387 merge_args="--no-log --no-ff"
388 if ! do_with_author output eval \
389 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
390 $merge_args $strategy_args -m "$msg_content" $new_parents'
392 printf "%s
\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
393 die_with_patch $sha1 "Error redoing merge
$sha1"
396 printf "%s
\n" $new_parents >"$GIT_DIR"/MERGE_HEAD
397 printf "%s
\n" "$msg_content" >"$GIT_DIR"/MERGE_MSG
398 if output git cherry-pick -m 1 -n "$sha1"
400 do_with_author output git commit --no-verify -F "$GIT_DIR"/MERGE_MSG ||
401 die_with_patch $sha1 "Could not replay merge
$sha1"
403 die_with_patch $sha1 "Could not pick merge
$sha1"
406 echo "$sha1 $
(git rev-parse HEAD^
0)" >> "$rewritten_list"
409 output eval git cherry-pick \
410 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
411 "$strategy_args" "$@
" ||
412 die_with_patch $sha1 "Could not pick
$sha1"
421 *1[0-9]|*[04-9]) echo "$1"th;;
428 update_squash_messages () {
429 if test -f "$squash_msg"; then
430 mv "$squash_msg" "$squash_msg".bak || exit
432 -e "1s
/^. This is a combination of \
(.
*\
) commits\.
/\
1/p
" \
433 -e "q
" < "$squash_msg".bak)+1))
435 printf '%s\n' "$comment_char This is a combination of
$count commits.
"
436 sed -e 1d -e '2,/^./{
438 }' <"$squash_msg".bak
441 commit_message HEAD > "$fixup_msg" || die "Cannot
write $fixup_msg"
444 printf '%s\n' "$comment_char This is a combination of
2 commits.
"
445 printf '%s\n' "$comment_char The first commit
's message is:"
454 printf '%s
\n' "$comment_char This is the $(nth_string $count) commit message:"
460 printf '%s
\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
462 # Change the space after the comment character to TAB:
463 commit_message $2 | git stripspace --comment-lines | sed -e 's
/ / /'
468 peek_next_command () {
469 git stripspace --strip-comments <"$todo" | sed -n -e 's
/ .
*//p
' -e q
472 # A squash/fixup has failed. Prepare the long version of the squash
473 # commit message, then die_with_patch. This code path requires the
474 # user to edit the combined commit message for all commits that have
475 # been squashed/fixedup so far. So also erase the old squash
476 # messages, effectively causing the combined commit to be used as the
477 # new basis for any further squash/fixups. Args: sha1 rest
478 die_failed_squash() {
479 mv "$squash_msg" "$msg" || exit
481 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
483 warn "Could not apply $1... $2"
487 flush_rewritten_pending() {
488 test -s "$rewritten_pending" || return
489 newsha1="$(git rev-parse HEAD^0)"
490 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
491 rm -f "$rewritten_pending"
494 record_in_rewritten() {
495 oldsha1="$(git rev-parse $1)"
496 echo "$oldsha1" >> "$rewritten_pending"
498 case "$(peek_next_command)" in
502 flush_rewritten_pending
508 if test "$(git rev-parse HEAD)" = "$squash_onto"
510 # Set the correct commit message and author info on the
511 # sentinel root before cherry-picking the original changes
512 # without committing (-n). Finally, update the sentinel again
513 # to include these changes. If the cherry-pick results in a
514 # conflict, this means our behaviour is similar to a standard
515 # failed cherry-pick during rebase, with a dirty index to
516 # resolve before manually running git commit --amend then git
518 git commit --allow-empty --allow-empty-message --amend \
519 --no-post-rewrite -n -q -C $1 &&
521 git commit --allow-empty --allow-empty-message \
522 --amend --no-post-rewrite -n -q -C $1 \
523 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
524 die_with_patch $1 "Could not apply $1... $2"
527 die_with_patch $1 "Could not apply $1... $2"
532 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
533 read -r command sha1 rest < "$todo"
535 "$comment_char"*|''|noop|drop|d)
539 # Work around CR left by "read" (e.g. with Git for Windows' Bash
).
543 comment_for_reflog pick
546 do_pick
$sha1 "$rest"
547 record_in_rewritten
$sha1
550 comment_for_reflog reword
553 do_pick
$sha1 "$rest"
554 git commit
--amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} ||
{
555 warn
"Could not amend commit after successfully picking $sha1... $rest"
556 warn
"This is most likely due to an empty commit message, or the pre-commit hook"
557 warn
"failed. If the pre-commit hook failed, you may need to resolve the issue before"
558 warn
"you are able to reword the commit."
559 exit_with_patch
$sha1 1
561 record_in_rewritten
$sha1
564 comment_for_reflog edit
567 do_pick
$sha1 "$rest"
568 warn
"Stopped at $sha1... $rest"
569 exit_with_patch
$sha1 0
580 comment_for_reflog
$squash_style
582 test -f "$done" && has_action
"$done" ||
583 die
"Cannot '$squash_style' without a previous commit"
586 update_squash_messages
$squash_style $sha1
587 author_script_content
=$
(get_author_ident_from_commit HEAD
)
588 echo "$author_script_content" > "$author_script"
589 eval "$author_script_content"
590 if ! pick_one
-n $sha1
592 git rev-parse
--verify HEAD
>"$amend"
593 die_failed_squash
$sha1 "$rest"
595 case "$(peek_next_command)" in
597 # This is an intermediate commit; its message will only be
598 # used in case of trouble. So use the long version:
599 do_with_author output git commit
--amend --no-verify -F "$squash_msg" \
600 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
601 die_failed_squash
$sha1 "$rest"
604 # This is the final command of this squash/fixup group
605 if test -f "$fixup_msg"
607 do_with_author git commit
--amend --no-verify -F "$fixup_msg" \
608 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
609 die_failed_squash
$sha1 "$rest"
611 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG ||
exit
612 rm -f "$GIT_DIR"/MERGE_MSG
613 do_with_author git commit
--amend --no-verify -F "$GIT_DIR"/SQUASH_MSG
-e \
614 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
615 die_failed_squash
$sha1 "$rest"
617 rm -f "$squash_msg" "$fixup_msg"
620 record_in_rewritten
$sha1
623 read -r command rest
< "$todo"
625 printf 'Executing: %s\n' "$rest"
626 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
628 # Run in subshell because require_clean_work_tree can die.
630 (require_clean_work_tree
"rebase" 2>/dev
/null
) || dirty
=t
631 if test "$status" -ne 0
633 warn
"Execution failed: $rest"
635 warn
"and made changes to the index and/or the working tree"
637 warn
"You can fix the problem, and then run"
639 warn
" git rebase --continue"
641 if test $status -eq 127 # command not found
646 elif test "$dirty" = t
648 warn
"Execution succeeded: $rest"
649 warn
"but left changes to the index and/or the working tree"
650 warn
"Commit or stash your changes, and then run"
652 warn
" git rebase --continue"
658 warn
"Unknown command: $command $sha1 $rest"
659 fixtodo
="Please fix this using 'git rebase --edit-todo'."
660 if git rev-parse
--verify -q "$sha1" >/dev
/null
662 die_with_patch
$sha1 "$fixtodo"
668 test -s "$todo" && return
670 comment_for_reflog finish
&&
671 newhead
=$
(git rev-parse HEAD
) &&
674 message
="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
675 git update-ref
-m "$message" $head_name $newhead $orig_head &&
677 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
681 test ! -f "$state_dir"/verbose ||
682 git diff-tree
--stat $orig_head..HEAD
685 test -s "$rewritten_list" &&
686 git notes copy
--for-rewrite=rebase
< "$rewritten_list" ||
687 true
# we don't care if this copying failed
689 hook
="$(git rev-parse --git-path hooks/post-rewrite)"
690 if test -x "$hook" && test -s "$rewritten_list"; then
691 "$hook" rebase
< "$rewritten_list"
692 true
# we don't care if this hook failed
694 warn
"Successfully rebased and updated $head_name."
696 return 1 # not failure; just to break the do_rest loop
699 # can only return 0, when the infinite loop breaks
707 # skip picking commits whose parents are unchanged
708 skip_unnecessary_picks
() {
710 while read -r command rest
712 # fd=3 means we skip the command
713 case "$fd,$command" in
715 # pick a commit whose parent is current $onto -> skip
717 case "$(git rev-parse --verify --quiet "$sha1"^)" in
726 3,"$comment_char"*|
3,)
733 printf '%s\n' "$command${rest:+ }$rest" >&$fd
734 done <"$todo" >"$todo.new" 3>>"$done" &&
735 mv -f "$todo".new
"$todo" &&
736 case "$(peek_next_command)" in
738 record_in_rewritten
"$onto"
741 die
"Could not skip unnecessary pick commands"
744 transform_todo_ids
() {
745 while read -r command rest
748 "$comment_char"* |
exec)
749 # Be careful for oddball commands like 'exec'
750 # that do not have a SHA-1 at the beginning of $rest.
753 sha1
=$
(git rev-parse
--verify --quiet "$@" ${rest%%[ ]*}) &&
754 rest
="$sha1 ${rest#*[ ]}"
757 printf '%s\n' "$command${rest:+ }$rest"
758 done <"$todo" >"$todo.new" &&
759 mv -f "$todo.new" "$todo"
766 collapse_todo_ids
() {
767 transform_todo_ids
--short
770 # Rearrange the todo list that has both "pick sha1 msg" and
771 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
772 # comes immediately after the former, and change "pick" to
775 # Note that if the config has specified a custom instruction format
776 # each log message will be re-retrieved in order to normalize the
777 # autosquash arrangement
778 rearrange_squash
() {
779 # extract fixup!/squash! lines and resolve any referenced sha1's
780 while read -r pick sha1 message
782 test -z "${format}" || message
=$
(git log
-n 1 --format="%s" ${sha1})
784 "squash! "*|
"fixup! "*)
785 action
="${message%%!*}"
788 # skip all squash! or fixup! (but save for later)
792 "squash! "*|
"fixup! "*)
793 prefix
="$prefix${rest%%!*},"
801 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
802 # if it's a single word, try to resolve to a full sha1 and
803 # emit a second copy. This allows us to match on both message
805 if test "${rest#* }" = "$rest"; then
806 fullsha
="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
807 if test -n "$fullsha"; then
808 # prefix the action to uniquely identify this line as
809 # intended for full sha1 match
810 echo "$sha1 +$action $prefix $fullsha"
815 test -s "$1.sq" ||
return
818 while read -r pick sha1 message
821 *" $sha1 "*) continue ;;
823 printf '%s\n' "$pick $sha1 $message"
824 test -z "${format}" || message
=$
(git log
-n 1 --format="%s" ${sha1})
826 while read -r squash action msg_prefix msg_content
829 *" $squash "*) continue ;;
835 # full sha1 prefix test
836 case "$msg_content" in "$sha1"*) emit
=1;; esac ;;
838 # message prefix test
839 case "$message" in "$msg_content"*) emit
=1;; esac ;;
841 if test $emit = 1; then
842 if test -n "${format}"
844 msg_content
=$
(git log
-n 1 --format="${format}" ${squash})
846 msg_content
="$(echo "$msg_prefix" | sed "s
/,/! /g
")$msg_content"
848 printf '%s\n' "$action $squash $msg_content"
852 done >"$1.rearranged" <"$1"
853 cat "$1.rearranged" >"$1"
854 rm -f "$1.sq" "$1.rearranged"
857 # Add commands after a pick or after a squash/fixup serie
859 add_exec_commands
() {
862 while read -r insn rest
870 printf "%s %s\n" "$insn" "$rest"
878 # Check if the SHA-1 passed as an argument is a
879 # correct one, if not then print $2 in "$todo".badsha
880 # $1: the SHA-1 to test
881 # $2: the line number of the input
882 # $3: the input filename
883 check_commit_sha
() {
889 sha1_verif
="$(git rev-parse --verify --quiet $1^{commit})"
890 if test -z $sha1_verif
896 if test $badsha -ne 0
898 line
="$(sed -n -e "${2}p
" "$3")"
899 warn
"Warning: the SHA-1 is missing or isn't" \
900 "a commit in the following line:"
908 # prints the bad commits and bad commands
909 # from the todolist in stdin
910 check_bad_cmd_and_sha
() {
913 while read -r command rest
915 lineno
=$
(( $lineno + 1 ))
917 "$comment_char"*|
''|noop|x|
exec)
918 # Doesn't expect a SHA-1
921 # Work around CR left by "read" (e.g. with Git for
924 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f
)
925 if ! check_commit_sha
"${rest%%[ ]*}" "$lineno" "$1"
931 line
="$(sed -n -e "${lineno}p
" "$1")"
932 warn
"Warning: the command isn't recognized" \
933 "in the following line:"
943 # Print the list of the SHA-1 of the commits
944 # from stdin to stdout
945 todo_list_to_sha_list
() {
946 git stripspace
--strip-comments |
947 while read -r command sha1 rest
950 "$comment_char"*|
''|noop|x|
"exec")
953 long_sha
=$
(git rev-list
--no-walk "$sha1" 2>/dev
/null
)
954 printf "%s\n" "$long_sha"
960 # Use warn for each line in stdin
968 # Switch to the branch in $into and notify it in the reflog
970 GIT_REFLOG_ACTION
="$GIT_REFLOG_ACTION: checkout $onto_name"
971 output git checkout
$onto || die_abort
"could not detach HEAD"
972 git update-ref ORIG_HEAD
$orig_head
975 get_missing_commit_check_level
() {
976 check_level
=$
(git config
--get rebase.missingCommitsCheck
)
977 check_level
=${check_level:-ignore}
978 # Don't be case sensitive
979 printf '%s' "$check_level" |
tr 'A-Z' 'a-z'
982 # Check if the user dropped some commits by mistake
983 # Behaviour determined by rebase.missingCommitsCheck.
984 # Check if there is an unrecognized command or a
985 # bad SHA-1 in a command.
989 check_level
=$
(get_missing_commit_check_level
)
991 case "$check_level" in
993 # Get the SHA-1 of the commits
994 todo_list_to_sha_list
<"$todo".backup
>"$todo".oldsha1
995 todo_list_to_sha_list
<"$todo" >"$todo".newsha1
997 # Sort the SHA-1 and compare them
998 sort -u "$todo".oldsha1
>"$todo".oldsha1
+
999 mv "$todo".oldsha1
+ "$todo".oldsha1
1000 sort -u "$todo".newsha1
>"$todo".newsha1
+
1001 mv "$todo".newsha1
+ "$todo".newsha1
1002 comm -2 -3 "$todo".oldsha1
"$todo".newsha1
>"$todo".miss
1004 # Warn about missing commits
1005 if test -s "$todo".miss
1007 test "$check_level" = error
&& raise_error
=t
1009 warn
"Warning: some commits may have been dropped" \
1011 warn
"Dropped commits (newer to older):"
1013 # Make the list user-friendly and display
1014 opt
="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1015 git rev-list
$opt <"$todo".miss | warn_lines
1017 warn
"To avoid this message, use \"drop\" to" \
1018 "explicitly remove a commit."
1020 warn
"Use 'git config rebase.missingCommitsCheck' to change" \
1021 "the level of warnings."
1022 warn
"The possible behaviours are: ignore, warn, error."
1029 warn
"Unrecognized setting $check_level for option" \
1030 "rebase.missingCommitsCheck. Ignoring."
1034 if ! check_bad_cmd_and_sha
"$todo"
1039 if test $raise_error = t
1041 # Checkout before the first commit of the
1042 # rebase: this way git rebase --continue
1043 # will work correctly as it expects HEAD to be
1044 # placed before the commit of the next action
1047 warn
"You can fix this with 'git rebase --edit-todo'."
1048 die
"Or you can abort the rebase with 'git rebase --abort'."
1052 # The whole contents of this file is run by dot-sourcing it from
1053 # inside a shell function. It used to be that "return"s we see
1054 # below were not inside any function, and expected to return
1055 # to the function that dot-sourced us.
1057 # However, FreeBSD /bin/sh misbehaves on such a construct and
1058 # continues to run the statements that follow such a "return".
1059 # As a work-around, we introduce an extra layer of a function
1060 # here, and immediately call it after defining it.
1061 git_rebase__interactive
() {
1065 # do we have anything to commit?
1066 if git diff-index
--cached --quiet HEAD
--
1068 # Nothing to commit -- skip this commit
1070 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1071 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1072 die
"Could not remove CHERRY_PICK_HEAD"
1074 if ! test -f "$author_script"
1076 gpg_sign_opt_quoted
=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1077 die
"You have staged changes in your working tree. If these changes are meant to be
1078 squashed into the previous commit, run:
1080 git commit --amend $gpg_sign_opt_quoted
1082 If they are meant to go into a new commit, run:
1084 git commit $gpg_sign_opt_quoted
1086 In both case, once you're done, continue with:
1088 git rebase --continue
1091 .
"$author_script" ||
1092 die
"Error trying to find the author identity to amend commit"
1095 current_head
=$
(git rev-parse
--verify HEAD
)
1096 test "$current_head" = $
(cat "$amend") ||
1098 You have uncommitted changes in your working tree. Please, commit them
1099 first and then run 'git rebase --continue' again."
1100 do_with_author git commit
--amend --no-verify -F "$msg" -e \
1101 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1102 die
"Could not commit staged changes."
1104 do_with_author git commit
--no-verify -F "$msg" -e \
1105 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1106 die
"Could not commit staged changes."
1110 if test -r "$state_dir"/stopped-sha
1112 record_in_rewritten
"$(cat "$state_dir"/stopped-sha)"
1115 require_clean_work_tree
"rebase"
1126 git stripspace
--strip-comments <"$todo" >"$todo".new
1127 mv -f "$todo".new
"$todo"
1130 git stripspace
--comment-lines >>"$todo" <<\EOF
1132 You are editing the todo
file of an ongoing interactive rebase.
1133 To
continue rebase after editing
, run
:
1134 git rebase
--continue
1138 git_sequence_editor
"$todo" ||
1139 die
"Could not execute editor"
1146 git var GIT_COMMITTER_IDENT
>/dev
/null ||
1147 die
"You need to set your committer info first"
1149 comment_for_reflog start
1151 if test ! -z "$switch_to"
1153 GIT_REFLOG_ACTION
="$GIT_REFLOG_ACTION: checkout $switch_to"
1154 output git checkout
"$switch_to" -- ||
1155 die
"Could not checkout $switch_to"
1157 comment_for_reflog start
1160 orig_head
=$
(git rev-parse
--verify HEAD
) || die
"No HEAD?"
1161 mkdir
-p "$state_dir" || die
"Could not create temporary $state_dir"
1163 : > "$state_dir"/interactive || die
"Could not mark as interactive"
1165 if test t
= "$preserve_merges"
1167 if test -z "$rebase_root"
1169 mkdir
"$rewritten" &&
1170 for c
in $
(git merge-base
--all $orig_head $upstream)
1172 echo $onto > "$rewritten"/$c ||
1173 die
"Could not init rewritten commits"
1176 mkdir
"$rewritten" &&
1177 echo $onto > "$rewritten"/root ||
1178 die
"Could not init rewritten commits"
1180 # No cherry-pick because our first pass is to determine
1181 # parents to rewrite and skipping dropped commits would
1182 # prematurely end our probe
1185 merges_option
="--no-merges --cherry-pick"
1188 shorthead
=$
(git rev-parse
--short $orig_head)
1189 shortonto
=$
(git rev-parse
--short $onto)
1190 if test -z "$rebase_root"
1191 # this is now equivalent to ! -z "$upstream"
1193 shortupstream
=$
(git rev-parse
--short $upstream)
1194 revisions
=$upstream...
$orig_head
1195 shortrevisions
=$shortupstream..
$shorthead
1197 revisions
=$onto...
$orig_head
1198 shortrevisions
=$shorthead
1200 format
=$
(git config
--get rebase.instructionFormat
)
1201 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1202 git rev-list
$merges_option --format="%m%H ${format:-%s}" \
1203 --reverse --left-right --topo-order \
1204 $revisions ${restrict_revision+^$restrict_revision} | \
1206 while read -r sha1 rest
1209 if test -z "$keep_empty" && is_empty_commit
$sha1 && ! is_merge_commit
$sha1
1211 comment_out
="$comment_char "
1216 if test t
!= "$preserve_merges"
1218 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1220 if test -z "$rebase_root"
1223 for p
in $
(git rev-list
--parents -1 $sha1 | cut
-d' ' -s -f2-)
1225 if test -f "$rewritten"/$p
1233 if test f
= "$preserve"
1235 touch "$rewritten"/$sha1
1236 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1241 # Watch for commits that been dropped by --cherry-pick
1242 if test t
= "$preserve_merges"
1245 # Save all non-cherry-picked changes
1246 git rev-list
$revisions --left-right --cherry-pick | \
1247 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1248 # Now all commits and note which ones are missing in
1249 # not-cherry-picks and hence being dropped
1250 git rev-list
$revisions |
1253 if test -f "$rewritten"/$rev && test "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
1255 # Use -f2 because if rev-list is telling us this commit is
1256 # not worthwhile, we don't want to track its multiple heads,
1257 # just the history of its first-parent for others that will
1258 # be rebasing on top of it
1259 git rev-list
--parents -1 $rev | cut
-d' ' -s -f2 > "$dropped"/$rev
1260 sha1
=$
(git rev-list
-1 $rev)
1261 sane_grep
-v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1262 rm "$rewritten"/$rev
1267 test -s "$todo" ||
echo noop
>> "$todo"
1268 test -n "$autosquash" && rearrange_squash
"$todo"
1269 test -n "$cmd" && add_exec_commands
"$todo"
1271 todocount
=$
(git stripspace
--strip-comments <"$todo" |
wc -l)
1272 todocount
=${todocount##* }
1276 $comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
1279 git stripspace
--comment-lines >>"$todo" <<\EOF
1281 However
, if you remove everything
, the rebase will be aborted.
1285 if test -z "$keep_empty"
1287 printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
1291 has_action
"$todo" ||
1294 cp "$todo" "$todo".backup
1296 git_sequence_editor
"$todo" ||
1297 die_abort
"Could not execute editor"
1299 has_action
"$todo" ||
1306 test -d "$rewritten" ||
test -n "$force_rebase" || skip_unnecessary_picks
1312 # ... and then we call the whole thing.
1313 git_rebase__interactive